{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainUnit;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL, KOLMHAboutDialog {$IFNDEF KOL_MCK}, mirror, Classes,  Controls, mckCtrls, mckObjs,MCKMHAboutDialog {$ENDIF},Funcs{,XPDesign};
{$ELSE}
{$I uses.inc} mirror,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  PForm1 = ^TForm1;
  TForm1 = object(TObj)
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    MainMenu1: TKOLMainMenu;
    OD: TKOLOpenSaveDialog;
    Panel4: TKOLPanel;
    KOLApplet1: TKOLApplet;
    MainTree: TKOLTreeView;
    PaintBox1: TKOLPaintBox;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    Label3: TKOLLabel;
    Label4: TKOLLabel;
    AuthorName: TKOLLabel;
    WebPage: TKOLLabel;
    Splitter1: TKOLSplitter;
    Splitter2: TKOLSplitter;
    Label5: TKOLLabel;
    Label6: TKOLLabel;
    Label7: TKOLLabel;
    Panel1: TKOLPanel;
    Panel2: TKOLPanel;
    PaintBox2: TKOLPaintBox;
    MHAboutDialog1: TKOLMHAboutDialog;
    OpenSaveDialog1: TKOLOpenSaveDialog;
    procedure KOLForm1N2Menu(Sender: PMenu; Item: Integer);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure KOLForm1N4Menu(Sender: PMenu; Item: Integer);
    function MainTreeTVSelChanging(Sender: PControl; oldItem,
      newItem: Cardinal): Boolean;
    procedure KOLForm1Destroy(Sender: PObj);
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
    procedure PaintBox2Paint(Sender: PControl; DC: HDC);
    procedure AuthorNameMouseEnter(Sender: PObj);
    procedure AuthorNameMouseLeave(Sender: PObj);
    procedure WebPageMouseEnter(Sender: PObj);
    procedure WebPageMouseLeave(Sender: PObj);
    procedure AuthorNameClick(Sender: PObj);
    procedure WebPageClick(Sender: PObj);
    procedure PaintBox2MouseDown(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure PaintBox2MouseMove(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure PaintBox2MouseUp(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure KOLForm1Show(Sender: PObj);
    procedure ScrollBox1Resize(Sender: PObj);
    procedure MainMenu1N6Menu(Sender: PMenu; Item: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    Version,App:String;
    procedure LoadImageList;
    procedure OpenWlFile(FN:String);
  end;
  RItem=record
    BM:PBitmap;
    Data:PStream;
    Size:Word;
    Offset:DWord;
    Colors:Byte;
  end;

  RWlFile=record
    Name:String;
    Size:Cardinal;
    Items:array of RItem;
    TextureCount:Word;
    SpriteCount:Word;
    UnknowCount:Word;
    TextureSize:DWord;
    SpriteSize:DWord;
    UnknowSize:DWord;
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;
  MainTreeILs,MainIL:HImageList;
  BackBM:PBitmap;
  RootItem,TextureItem,SpriteItem,UnknowItem:THandle;
  ItemType:Integer;
  Zoom,LastZoom:Real;
  ZoomFactor:Real;
  SaveZoom,Association,Creating:Boolean;
  ZoomY:Integer;
  Zooming,Zoomed:Boolean;
  WorkFile:RWlFile;
  ZoomedIM:PBitmap;
  MoveY:Integer;
  MoveX:Integer;
  LastY:Integer;
  LastX:Integer;
  Moving:Boolean;

const
  FileIm=0;
  TextDirIm=1;
  SpriteDirIm=2;
  UnknowDirIm=3;
  TextDocIm=4;
  SpriteDocIm=5;
  UnknowDocIm=6;

  TextureWidth=64;
  TextureHeight=64;
  TextureWidthS='64';
  TextureHeightS='64';
  TextureSize=TextureWidth*TextureHeight;
  TextureSizeS='4096';
  ftUnKnow=0;
  ftTexture=1;
  ftSprite=2;

  DefaultTexturesS='106';
  DefaultTextures=106;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainUnit_1.inc}
{$ENDIF}

//{$R Wolf3d.res}
{$R Icons.res}
{$R Images.res}
{$R Palette.res}

function BitCount(C:Integer):String;
begin
  case C of
    0..2:Result:='1';
    3..4:Result:='2';
    5..8:Result:='3';
    9..16:Result:='4';
    17..32:Result:='5';
    33..64:Result:='6';
    65..128:Result:='7';
    129..256:Result:='8';
  end;// case
end;
procedure DrawCross(Canvas:PCanvas; x,y,l:Integer);
begin
  // Good
  Canvas.MoveTo(x-l,y);
  Canvas.LineTo(x+l+1,y);
  Canvas.MoveTo(x,y-l);
  Canvas.LineTo(x,y+l+1);
end;

procedure DrawCrossRect(Canvas:PCanvas; w,h,x,y,l:Integer);
begin
  // Good
  DrawCross(Canvas,-1+x,-1+y,l);
  DrawCross(Canvas,w+x,-1+y,l);
  DrawCross(Canvas,-1+x,h+y,l);
  DrawCross(Canvas,w+x,h+y,l);
end;

procedure TForm1.LoadImageList;
begin
  // Good

//  ImageList1.LoadBitMap
  MainTreeILs:=ImageList_Create(16,16,ILC_COLOR32 or ILC_MASK,4,0);
//  ImageList_LoadBitMap(hInstance,'FILEPICS',16,0,clRed);
  ImageList_AddMasked(MainTreeILs,LoadBitMap(hInstance,'FILEPICS'),clRed);
  ImageList_AddMasked(MainTreeILs,LoadBitMap(hInstance,'TEXTDIRPICS'),clRed);
  ImageList_AddMasked(MainTreeILs,LoadBitMap(hInstance,'SPRITEDIRPICS'),clRed);
  ImageList_AddMasked(MainTreeILs,LoadBitMap(hInstance,'UNKNOWDIRPICS'),clRed);
  ImageList_AddMasked(MainTreeILs,LoadBitMap(hInstance,'TEXTDOCPICS'),clRed);
  ImageList_AddMasked(MainTreeILs,LoadBitMap(hInstance,'SPRITEDOCPICS'),clRed);
  ImageList_AddMasked(MainTreeILs,LoadBitMap(hInstance,'UNKNOWDOCPICS'),clRed);
  SendMessage(MainTree.Handle,TVM_SETIMAGELIST,TVSIL_NORMAL,MainTreeILs);
  MainIL:=ImageList_Create(32,32,ILC_COLOR32 or ILC_MASK,4,0);
  ImageList_AddMasked(MainIL,LoadBitMap(hInstance,'FILEPIC'),clRed);
  ImageList_AddMasked(MainIL,LoadBitMap(hInstance,'TEXTDIRPIC'),clRed);
  ImageList_AddMasked(MainIL,LoadBitMap(hInstance,'SPRITEDIRPIC'),clRed);
  ImageList_AddMasked(MainIL,LoadBitMap(hInstance,'UNKNOWDIRPIC'),clRed);
  ImageList_AddMasked(MainIL,LoadBitMap(hInstance,'TEXTDOCPIC'),clRed);
  ImageList_AddMasked(MainIL,LoadBitMap(hInstance,'SPRITEDOCPIC'),clRed);
  ImageList_AddMasked(MainIL,LoadBitMap(hInstance,'UNKNOWDOCPIC'),clRed);
end;

procedure FreeFile(FF:RWlFile);
var
  i:Integer;
begin
  // So-so
  For i:=0 to Length(FF.Items)-1 do
  begin
    FF.Items[i].BM.Free;
    FF.Items[i].Data.Free;
  end;
  SetLength(FF.Items,0);
end;

procedure TForm1.OpenWlFile(FN:String);
var
  i: Integer;
  tmpItem:THandle;
  tmp:^Integer;
  TMPFile:PStream;
  TMPItemCount:Word;
  TMPBuffer:array [0..65535] of Byte;
begin
  with WorkFile do
  begin
  MainTree.Clear;
  FreeFile(WorkFile);
  WorkFile.Name:=FN;
  TMPFile:=NewReadFileStream(WorkFile.Name);
  WorkFile.Size:=TMPFile.Size;
  TMPFile.Read(TMPItemCount,SizeOf(TMPItemCount));
  SetLength(WorkFile.Items,TMPItemCount);
  TMPFile.Seek($06,spBegin);
  For i:=0 to TMPItemCount-1 do
    TMPFile.Read(WorkFile.Items[i].Offset,SizeOf(WorkFile.Items[i].Offset));
  For i:=0 to TMPItemCount-1 do
    TMPFile.Read(WorkFile.Items[i].Size,SizeOf(WorkFile.Items[i].Size));

  RootItem:=MainTree.TVInsert(TVI_Root,TVI_FIRST,ExtractFileName(WorkFile.Name));
  MainTree.TVItemImage[RootItem]:=FileIm;
  MainTree.TVItemSelImg[RootItem]:=FileIm;
  TextureItem:=MainTree.TVInsert(RootItem,TVI_LAST,'');
  MainTree.TVItemImage[TextureItem]:=TextDirIm;
  MainTree.TVItemSelImg[TextureItem]:=TextDirIm;
  SpriteItem:=MainTree.TVInsert(RootItem,TVI_LAST,'');
  MainTree.TVItemImage[SpriteItem]:=SpriteDirIm;
  MainTree.TVItemSelImg[SpriteItem]:=SpriteDirIm;
  UnknowItem:=MainTree.TVInsert(RootItem,TVI_LAST,' ');
  MainTree.TVItemImage[UnknowItem]:=UnknowDirIm;
  MainTree.TVItemSelImg[UnknowItem]:=UnknowDirIm;

  TextureCount:=0;
  SpriteCount:=0;
  UnknowCount:=0;

  TextureSize:=0;
  SpriteSize:=0;
  UnknowSize:=0;

  for i:=0 to TMPItemCount-1 do
  begin
    case i of
      0..105:
      begin
        Inc(TextureCount);
        Inc(TextureSize,WorkFile.Items[i].Size);
        tmpItem:=MainTree.TVInsert(TextureItem,TVI_LAST,' '+Int2Str(TextureCount));
        MainTree.TVItemImage[tmpItem]:=TextDocIm;
        MainTree.TVItemSelImg[tmpItem]:=TextDocIm;
      end;

      106..540:
      begin
        Inc(SpriteCount);
        Inc(SpriteSize,WorkFile.Items[i].Size);
        tmpItem:=MainTree.TVInsert(SpriteItem,TVI_LAST,' '+Int2Str(SpriteCount));
        MainTree.TVItemImage[tmpItem]:=SpriteDocIm;
        MainTree.TVItemSelImg[tmpItem]:=SpriteDocIm;
      end;
      Else
      begin
        Inc(UnknowCount);
        Inc(UnknowSize,WorkFile.Items[i].Size);
        tmpItem:=MainTree.TVInsert(UnknowItem,TVI_LAST,'  '+Int2Str(UnknowCount));
        MainTree.TVItemImage[tmpItem]:=UnknowDocIm;
        MainTree.TVItemSelImg[tmpItem]:=UnknowDocIm;
      end;
    end;  //case
    New(tmp);
    tmp^:=i;
    MainTree.TVItemData[tmpItem]:=tmp;
    TMPFile.Seek(WorkFile.Items[i].Offset,spBegin);
    TMPFile.Read(TMPBuffer,WorkFile.Items[i].Size);
    WorkFile.Items[i].Data:=NewMemoryStream;
    WorkFile.Items[i].Data.Write(TMPBuffer,WorkFile.Items[i].Size);
  end;
  TMPFile.Free;
  AuthorName.Visible:=False;
  WebPage.Visible:=False;
  MainTree.OnTVSelChanging(Form,0,RootItem);
  end;
end;

procedure TForm1.KOLForm1N2Menu(Sender: PMenu; Item: Integer);

begin
  if not OD.Execute then
    Exit;
  OpenWlFile(OD.FileName);
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
var
  WLFileKey,WlProgKey,WlProgOpenKey,WlProgIconKey:HKEY;
begin
  // V1.0 22-jan-2002
  // Done it
  // V1.8 Deluxe 16-feb-2002
  // Uhhh such more
  // V1.81 Deluxe 17-feb-2002
  // +Add DragnDrop Open
  // +Add File Icon
  // +Add So-so Association
  // +Add Capture Mouse

  // 5. Opt
  // 6. Transpatrent
  // 7. File Asso
  // 8. Save
  // 9. Export
  // 10. Import
  // 11. New
  // 12. Zero
  // 13. Safe-Load
  // 14. Mini-Res
  // 15. Menu
  // 16. Pack
  // 17. About
  // 18. Hints/Status Bar
  // 19. ToolBar
  // 20. Pop-Menus
  // 21. Free-Resouse
  // 22. Scroll Image
  // 23. Show Binary
  // 24. Show File Data
  // 25. Show File Version
  // 26. Zero Items
  // 27. Swap Items
  // 28. Delete Items
  // 29. Move Item
  // 30. Add Item
  // 31. Insert Item
  // 32. Change Item
  // 33. Optimize
  // 34. Consts
  // 35. Label Auto-Size
  // 36. XP Adaptation (48x48 icon and etc)
  // 37. Hide-UnUsed
  // 38. Remake Resource
  Version:='1.81 Deluxe';
//  App:='Wolfenstein 3D Converter';
  App:='Wolf3D Graphics Converter';
  Form1.Form.Caption:=App+' V'+Version;
  LoadImageList;
  ZoomFactor:=0.05;
  Creating:=True;
  SaveZoom:=not True;
  BackBM:=NewBitmap(0,0);
  BackBM.LoadFromResourceName(hInstance,'BackG');
  BMPInit;
  ItemType:=-1;
//  PaintBox1.Width:=220;
  Label1.Caption:=App;
  Label2.Caption:='Version: '+Version;
  Label3.Caption:='Author: ';
  AuthorName.Left:=Label3.Left+Label3.Width;
  AuthorName.Caption:='Zharov Dmitry';
  Label4.Caption:='Web Page: ';
  WebPage.Left:=Label4.Left+Label4.Width;
  WebPage.Caption:='http://delphisoft.boom.ru';
  Zoom:=1;
  Association:=True;
  if Association then
  begin
    WLFileKey:=RegKeyOpenRead(HKEY_CLASSES_ROOT,'.wl6');
    if WLFileKey<>0 then
    begin
    end
    Else
    begin
      WLFileKey:=RegKeyOpenCreate(HKEY_CLASSES_ROOT,'.wl6');
      RegKeySetStr(WlFileKey,'','MacroHard.Wolfenstein3D.WL6');
      WlProgKey:=RegKeyOpenCreate(HKEY_CLASSES_ROOT,'MacroHard.Wolfenstein3D.WL6');
      RegKeySetStr(WlProgKey,'','Wolfenstein3D Resource File');
      WlProgOpenKey:=RegKeyOpenCreate(HKEY_CLASSES_ROOT,'MacroHard.Wolfenstein3D.WL6\Shell\Open\Command');
      RegKeySetStr(WlProgOpenKey,'','"'+ParamStr(0)+'" "%1"');
      WlProgIconKey:=RegKeyOpenCreate(HKEY_CLASSES_ROOT,'MacroHard.Wolfenstein3D.WL6\DefaultIcon');
      RegKeySetStr(WlProgIconKey,'',ParamStr(0)+',1');
    end;
  end;

end;

procedure TForm1.KOLForm1N4Menu(Sender: PMenu; Item: Integer);
begin
  Form.Close;
end;

function TForm1.MainTreeTVSelChanging(Sender: PControl; oldItem,
  newItem: Cardinal): Boolean;
var
  p:^integer;
begin
  Label1.Caption:=MainTree.TVItemText[newItem];
  ItemType:=MainTree.TVItemImage[newItem];
  if not SaveZoom then
    Zoom:=1;
  Zoomed:=False;  

  case ItemType  of
    FileIm:
    begin
      // So-so
      Label2.Caption:='Wolf3D Grafic File';
      Label3.Caption:='File Size: '+Int2Str(WorkFile.Size);
      Label4.Caption:='Elements: '+Int2Str(Length(WorkFile.Items));
    end;
    TextDirIm:
    begin
      // Good
      Label2.Caption:='Texture Section';
      Label3.Caption:='Size: '+Int2Str(WorkFile.TextureSize);
      Label4.Caption:='Elements: '+Int2Str(WorkFile.TextureCount);
    end;
    SpriteDirIm:
    begin
      // Good
      Label2.Caption:='Sprite Section';
      Label3.Caption:='Size: '+Int2Str(WorkFile.SpriteSize);
      Label4.Caption:='Elements: '+Int2Str(WorkFile.SpriteCount);
    end;
    UnknowDirIm:
    begin
      // Good
      Label2.Caption:='Unknow Section';
      Label3.Caption:='Size: '+Int2Str(WorkFile.UnknowSize);
      Label4.Caption:='Elements: '+Int2Str(WorkFile.UnknowCount);
    end;
    TextDocIm:
    begin
      // Good
      p:=(MainTree.TVItemData[newItem]);
   //   if WorkFile.Items[p^].Size>0 then
//      begin
        if WorkFile.Items[p^].BM=nil then
          GenerateImage(p^);
        Label2.Caption:='Texture Element';
        Label3.Caption:='Num: '+Int2Str(p^+1);
        Label4.Caption:='Size: '+TextureSizeS;
        Label5.Caption:='Width: '+TextureWidthS;
        Label6.Caption:='Height: '+TextureHeightS;
        Label7.Caption:='Colors: '+Int2Str(WorkFile.Items[p^].Colors)+' ('+BitCount(WorkFile.Items[p^].Colors)+' bit)';
  {    end
      Else
      begin
        Label2.Caption:='Zero Texture Element';
        Label3.Caption:='Num: '+Int2Str(p^+1);
      end;}
    end;
    SpriteDocIm:
    begin
      // Good
      p:=(MainTree.TVItemData[newItem]);
      if WorkFile.Items[p^].BM=nil then
        GenerateImage(p^);
      Label2.Caption:='Sprite Element';
      Label3.Caption:='Num: '+Int2Str(p^+1-WorkFile.TextureCount);
      Label4.Caption:='Size: '+Int2Str(WorkFile.Items[p^].Size);
      Label5.Caption:='Width: '+Int2Str(WorkFile.Items[p^].BM.Width);
      Label6.Caption:='Height: '+TextureHeightS;
      Label7.Caption:='Colors: '+Int2Str(WorkFile.Items[p^].Colors)+' ('+BitCount(WorkFile.Items[p^].Colors)+' bit)';

    end;
    UnknowDocIm:
    begin
      // Good
      Label2.Caption:='Unknow Element';
      p:=(MainTree.TVItemData[newItem]);
      Label3.Caption:='Num: '+Int2Str(p^+1-WorkFile.TextureCount-WorkFile.SpriteCount);
      Label4.Caption:='Size: '+Int2Str(WorkFile.Items[p^].Size);
    end;
  end; //case
  PaintBox1.Invalidate;
  PaintBox2.Invalidate;
end;

procedure TForm1.KOLForm1Destroy(Sender: PObj);
begin
  BackBM.Free;
  FreeFile(WorkFile);
end;

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
var
  TMPRect:TRect;
  I:PIcon;
begin

  TMPRect.Left:=0;
  TMPRect.Top:=0;
  TMPRect.Right:=BackBM.Width;
  TMPRect.Bottom:=BackBM.Height;
  PaintBox1.Canvas.CopyRect(TMPRect,BackBM.Canvas,TMPRect);
  PaintBox1.Canvas.Pen.Color:=clRed;
  PaintBox1.Canvas.MoveTo(0,71);
  PaintBox1.Canvas.LineTo(PaintBox1.Width,71);
  if ItemType=-1 then
  begin
    I:=NewIcon;
    I.Handle:=LoadIcon(hInstance,'MainIco');
    I.Draw(DC,14,14);
    I.Free;
  end
  Else
    ImageList_Draw(MainIL,ItemType,PaintBox1.Canvas.Handle,14,14,0);


end;

procedure TForm1.PaintBox2Paint(Sender: PControl; DC: HDC);
var
  DRect,SRect:TRect;
  w,h:Integer;
  TMPB:PBitMap;
  p:^Integer;
  xoffset,yoffset:Integer;
begin
  case ItemType of
    TextDocIm:
    begin
      p:=(MainTree.TVItemData[MainTree.TVSelected]);
      if WorkFile.Items[P^].Size<=0 then
        Exit;
      w:=Trunc(TextureWidth*Zoom);
      h:=Trunc(TextureHeight*Zoom);
      {
      if w<>PaintBox2.Width then
      PaintBox2.Width:=w;
      if h<>PaintBox2.Height then
        PaintBox2.Height:=h;
      if PaintBox2.Left<>ScrollBox1.Width div 2-w div 2 then
        PaintBox2.Left:=ScrollBox1.Width div 2-w div 2;
      if PaintBox2.Top<>ScrollBox1.Height div 2-h div 2 then
        PaintBox2.Top:=ScrollBox1.Height div 2-h div 2;}

      xoffset:=PaintBox2.Width div 2-w div 2;
      yoffset:=PaintBox2.Height div 2-h div 2;

      DRect.Left:=xoffset+MoveX;
      DRect.Right:=w+xoffset+MoveX;
      DRect.Top:=yoffset+MoveY;
      DRect.Bottom:=h+yoffset+MoveY;

      SRect.Left:=0;
      SRect.Right:=PaintBox2.Width-1;
      SRect.Top:=0;
      SRect.Bottom:=PaintBox2.Height-1;

   {   Rect1.Left:=0;
      Rect1.Right:=ScrollBox1.Width-1;
      Rect1.Top:=0;
      Rect1.Bottom:=ScrollBox1.Height-1;

      Rect2.Left:=GetScrollPos();
      Rect2.Right:=ScrollBox1.Width-1;
      Rect2.Top:=0;
      Rect2.Bottom:=ScrollBox1.Height-1;
    }

      PaintBox2.Canvas.FillRect(SRect);
      SetStretchBltMode(PaintBox2.Canvas.Handle,HALFTONE);
      WorkFile.Items[P^].BM.StretchDraw(PaintBox2.Canvas.Handle,DRect);

      DrawCrossRect(PaintBox2.Canvas,w,h,xoffset+MoveX,yoffset+MoveY,10);

    end;

    SpriteDocIm:
    begin
      p:=(MainTree.TVItemData[MainTree.TVSelected]);

      if WorkFile.Items[P^].Size<=0 then
        Exit;
      w:=Trunc(WorkFile.Items[P^].BM.Width*Zoom);
      h:=Trunc(TextureHeight*Zoom);
      xoffset:=PaintBox2.Width div 2-w div 2;
      yoffset:=PaintBox2.Height div 2-h div 2;

      DRect.Left:=xoffset;
      DRect.Right:=w+xoffset;
      DRect.Top:=0+yoffset;
      DRect.Bottom:=h+yoffset;
      PaintBox2.Canvas.FillRect(DRect);
      SetStretchBltMode(PaintBox2.Canvas.Handle,HALFTONE);
      WorkFile.Items[P^].BM.StretchDraw(PaintBox2.Canvas.Handle,DRect);

      DrawCrossRect(PaintBox2.Canvas,w,h,xoffset,yoffset,10);

    end;
  end;  //case
end;

procedure TForm1.AuthorNameMouseEnter(Sender: PObj);
begin
  AuthorName.Font.Color:=clBlue;
end;

procedure TForm1.AuthorNameMouseLeave(Sender: PObj);
begin
  AuthorName.Font.Color:=clBlack;
end;

procedure TForm1.WebPageMouseEnter(Sender: PObj);
begin
  WebPage.Font.Color:=clBlue;
end;

procedure TForm1.WebPageMouseLeave(Sender: PObj);
begin
  WebPage.Font.Color:=clBlack;
end;

procedure TForm1.AuthorNameClick(Sender: PObj);
begin
  ShellExecute(0,nil,'mailto:Gendalf_the_gr@mail.ru',nil,nil,0);
end;

procedure TForm1.WebPageClick(Sender: PObj);
begin
  ShellExecute(0,nil,'http://delphisoft.boom.ru',nil,nil,0);
end;

procedure TForm1.PaintBox2MouseDown(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  if Mouse.Button=mbLeft then
  begin
    LastZoom:=Zoom;
    ZoomY:=Mouse.Y;
    Zooming:=True;
    Moving:=False;
  end
  Else
  begin
//    LastMoveY:=Mouse.Y;
//    LastMoveX:=Mouse.X;
//    MoveX:=0;
//    MoveY:=0;
//    StartX:=Mouse.Y;
//    Start.Y
//    Moving:=True;
//    Moving:=True;
  end;
//  SetCapture(PaintBox2.Handle);
end;

procedure TForm1.PaintBox2MouseMove(Sender: PControl;
  var Mouse: TMouseEventData);
var
  w,h:Integer;
begin

  if Zooming then
  begin

    if (ZoomY-Mouse.Y)*ZoomFactor+LastZoom>0 then
    begin
      Zoom:=(ZoomY-Mouse.Y)*ZoomFactor+LastZoom;
      Zoomed:=False;
    end;
      w:=Trunc(TextureWidth*Zoom);
      h:=Trunc(TextureHeight*Zoom);

  //    if w<>PaintBox2.Width then
//      PaintBox2.Width:=w;
//      if h<>PaintBox2.Height then
//      PaintBox2.Height:=h;
//      if PaintBox2.Left<>ScrollBox1.Width div 2-w div 2 then
//        PaintBox2.Left:=ScrollBox1.Width div 2-w div 2;
//      if PaintBox2.Top<>ScrollBox1.Height div 2-h div 2 then
//        PaintBox2.Top:=ScrollBox1.Height div 2-h div 2;
    PaintBox2.Invalidate;
  end;

  if Moving then
  begin
//      MoveX:=Mouse.X-LastX;
//      MoveY:=Mouse.Y-LastY;
//      w:=Trunc(TextureWidth*Zoom);
//      h:=Trunc(TextureHeight*Zoom);

  //    if w<>PaintBox2.Width then
//      PaintBox2.Width:=w;
//      if h<>PaintBox2.Height then
//        PaintBox2.Height:=h;
//      if PaintBox2.Left<>ScrollBox1.Width div 2-w div 2 then
//        PaintBox2.Left:=ScrollBox1.Width div 2-w div 2;
//      if PaintBox2.Top<>ScrollBox1.Height div 2-h div 2 then
//        PaintBox2.Top:=ScrollBox1.Height div 2-h div 2;
    PaintBox2.Invalidate;
  end;
end;

procedure TForm1.PaintBox2MouseUp(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  if Zooming then
  begin
    Zooming:=False;
    ReleaseCapture;
  end;

  if Moving then
  begin
    Moving:=False;
    ReleaseCapture;
  end;
end;

procedure TForm1.KOLForm1Show(Sender: PObj);
begin
  if Creating then
  begin
  if ParamStr(1)<>'' then
  begin
    OpenWlFile(ParamStr(1));
    AuthorName.Visible:=False;
    WebPage.Visible:=False;
    MainTree.OnTVSelChanging(Form,0,RootItem);
  end;
  Creating:=False;
  end;
end;

procedure TForm1.ScrollBox1Resize(Sender: PObj);
begin
//  PaintBox2.Width:=ScrollBox1.Width-1;
//  PaintBox2.Height:=ScrollBox1.Height-1;
end;

procedure TForm1.MainMenu1N6Menu(Sender: PMenu; Item: Integer);
begin
  MHAboutDialog1.Execute;
end;

end.










